/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <signalmanager.h>
#include <pysidemetafunction.h>
#include <algorithm>
#include <set>
#include <iterator>

// module include
#include "pyside6_qtquick3d_python.h"

// main header
#include "qquick3dgeometry_wrapper.h"

// inner classes
#include "qquick3dgeometry_attribute_wrapper.h"

#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}

// Native ---------------------------------------------------------

void QQuick3DGeometryWrapper::resetPyMethodCache()
{
    std::fill_n(m_PyMethodCache, sizeof(m_PyMethodCache) / sizeof(m_PyMethodCache[0]), false);
}

QQuick3DGeometryWrapper::QQuick3DGeometryWrapper(QQuick3DObject * parent) : QQuick3DGeometry(parent)
{
    resetPyMethodCache();
    // ... middle
}

void QQuick3DGeometryWrapper::childEvent(QChildEvent * event)
{
    if (m_PyMethodCache[0]) {
        return this->::QObject::childEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "childEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[0] = true;
        return this->::QObject::childEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QCHILDEVENT_IDX], event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::classBegin()
{
    if (m_PyMethodCache[1]) {
        return this->::QQuick3DObject::classBegin();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "classBegin";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[1] = true;
        return this->::QQuick3DObject::classBegin();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::componentComplete()
{
    if (m_PyMethodCache[2]) {
        return this->::QQuick3DObject::componentComplete();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "componentComplete";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[2] = true;
        return this->::QQuick3DObject::componentComplete();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::connectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[3]) {
        return this->::QObject::connectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "connectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[3] = true;
        return this->::QObject::connectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::customEvent(QEvent * event)
{
    if (m_PyMethodCache[4]) {
        return this->::QObject::customEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "customEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[4] = true;
        return this->::QObject::customEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::disconnectNotify(const QMetaMethod & signal)
{
    if (m_PyMethodCache[5]) {
        return this->::QObject::disconnectNotify(signal);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "disconnectNotify";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[5] = true;
        return this->::QObject::disconnectNotify(signal);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QMETAMETHOD_IDX], &signal)
    ));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

bool QQuick3DGeometryWrapper::event(QEvent * event)
{
    if (m_PyMethodCache[6])
        return this->::QObject::event(event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "event";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[6] = true;
        return this->::QObject::event(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2,
            "Invalid return value in function %s, expected %s, got %s.",
            "QQuick3DGeometry.event",
            "bool",
            Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

bool QQuick3DGeometryWrapper::eventFilter(QObject * watched, QEvent * event)
{
    if (m_PyMethodCache[7])
        return this->::QObject::eventFilter(watched, event);
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return false;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "eventFilter";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[7] = true;
        return this->::QObject::eventFilter(watched, event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(NN)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX], watched),
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QEVENT_IDX], event)
    ));
    bool invalidateArg2 = PyTuple_GET_ITEM(pyArgs, 1)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg2)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 1));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return false;
    }
    // Check return type
    Shiboken::Conversions::PythonToCppConversion pythonToCpp =
        Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), pyResult);
    if (!pythonToCpp) {
        Shiboken::warning(PyExc_RuntimeWarning, 2,
            "Invalid return value in function %s, expected %s, got %s.",
            "QQuick3DGeometry.eventFilter",
            "bool",
            Py_TYPE(pyResult)->tp_name);
        return false;
    }
    bool cppResult;
    pythonToCpp(pyResult, &cppResult);
    return cppResult;
}

void QQuick3DGeometryWrapper::markAllDirty()
{
    if (m_PyMethodCache[8]) {
        return this->::QQuick3DGeometry::markAllDirty();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "markAllDirty";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[8] = true;
        return this->::QQuick3DGeometry::markAllDirty();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::preSync()
{
    if (m_PyMethodCache[10]) {
        return this->::QQuick3DObject::preSync();
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "preSync";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[10] = true;
        return this->::QQuick3DObject::preSync();
    }

    Shiboken::AutoDecRef pyArgs(PyTuple_New(0));

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

void QQuick3DGeometryWrapper::timerEvent(QTimerEvent * event)
{
    if (m_PyMethodCache[11]) {
        return this->::QObject::timerEvent(event);
    }
    Shiboken::GilState gil;
    if (PyErr_Occurred())
        return;
    static PyObject *nameCache[2] = {};
    static const char *funcName = "timerEvent";
    Shiboken::AutoDecRef pyOverride(Shiboken::BindingManager::instance().getOverride(this, nameCache, funcName));
    if (pyOverride.isNull()) {
        gil.release();
        m_PyMethodCache[11] = true;
        return this->::QObject::timerEvent(event);
    }

    Shiboken::AutoDecRef pyArgs(Py_BuildValue("(N)",
        Shiboken::Conversions::pointerToPython(SbkPySide6_QtCoreTypes[SBK_QTIMEREVENT_IDX], event)
    ));
    bool invalidateArg1 = PyTuple_GET_ITEM(pyArgs, 0)->ob_refcnt == 1;

    Shiboken::AutoDecRef pyResult(PyObject_Call(pyOverride, pyArgs, nullptr));
    if (invalidateArg1)
        Shiboken::Object::invalidate(PyTuple_GET_ITEM(pyArgs, 0));
    if (pyResult.isNull()) {
        // An error happened in python code!
        PyErr_Print();
        return;
    }
}

const QMetaObject *QQuick3DGeometryWrapper::metaObject() const
{
    if (QObject::d_ptr->metaObject)
        return QObject::d_ptr->dynamicMetaObject();
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf == nullptr)
        return QQuick3DGeometry::metaObject();
    return PySide::SignalManager::retrieveMetaObject(reinterpret_cast<PyObject *>(pySelf));
}

int QQuick3DGeometryWrapper::qt_metacall(QMetaObject::Call call, int id, void **args)
{
    int result = QQuick3DGeometry::qt_metacall(call, id, args);
    return result < 0 ? result : PySide::SignalManager::qt_metacall(this, call, id, args);
}

void *QQuick3DGeometryWrapper::qt_metacast(const char *_clname)
{
    if (!_clname)
        return {};
    SbkObject *pySelf = Shiboken::BindingManager::instance().retrieveWrapper(this);
    if (pySelf && PySide::inherits(Py_TYPE(pySelf), _clname))
        return static_cast<void *>(const_cast< QQuick3DGeometryWrapper *>(this));
    return QQuick3DGeometry::qt_metacast(_clname);
}

QQuick3DGeometryWrapper::~QQuick3DGeometryWrapper()
{
    SbkObject *wrapper = Shiboken::BindingManager::instance().retrieveWrapper(this);
    Shiboken::Object::destroy(wrapper, this);
}

// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuick3DGeometry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    const QMetaObject *metaObject;
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuick3DGeometry >()))
        return -1;

    ::QQuick3DGeometryWrapper *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_ParseTuple(args, "|O:QQuick3DGeometry", &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QQuick3DGeometry::QQuick3DGeometry(QQuick3DObject*)
    if (numArgs == 0) {
        overloadId = 0; // QQuick3DGeometry(QQuick3DObject*)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DOBJECT_IDX], (pyArgs[0])))) {
        overloadId = 0; // QQuick3DGeometry(QQuick3DObject*)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometry_Init_TypeError;

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_parent = Shiboken::String::createStaticString("parent");
            if (PyDict_Contains(kwds, key_parent)) {
                value = PyDict_GetItem(kwds, key_parent);
                if (value && pyArgs[0]) {
                    errInfo.reset(key_parent);
                    Py_INCREF(errInfo.object());
                    goto Sbk_QQuick3DGeometry_Init_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DOBJECT_IDX], (pyArgs[0]))))
                        goto Sbk_QQuick3DGeometry_Init_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_parent);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                // fall through to handle extra keyword signals and properties
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QQuick3DObject *cppArg0 = nullptr;
        if (pythonToCpp[0])
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!PyErr_Occurred()) {
            // QQuick3DGeometry(QQuick3DObject*)
            void *addr = PySide::nextQObjectMemoryAddr();
            if (addr) {
                cptr = new (addr) ::QQuick3DGeometryWrapper(cppArg0);
                PySide::setNextQObjectMemoryAddr(0);
            } else {
                cptr = new ::QQuick3DGeometryWrapper(cppArg0);
            }

            Shiboken::Object::setParent(pyArgs[0], self);
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuick3DGeometry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QQuick3DGeometry_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::Object::setHasCppWrapper(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);

    // QObject setup
    PySide::Signal::updateSourceObject(self);
    metaObject = cptr->metaObject(); // <- init python qt properties
    if (!errInfo.isNull() && PyDict_Check(errInfo.object())) {
        if (!PySide::fillQtProperties(self, metaObject, errInfo))
            goto Sbk_QQuick3DGeometry_Init_TypeError;
    };


    return 1;

    Sbk_QQuick3DGeometry_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return -1;
}

static PyObject *Sbk_QQuick3DGeometryFunc_addAttribute(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.addAttribute";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[3];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0, 0};

    // invalid argument lengths
    if (numArgs == 2)
        goto Sbk_QQuick3DGeometryFunc_addAttribute_TypeError;

    if (!PyArg_UnpackTuple(args, "addAttribute", 1, 3, &(pyArgs[0]), &(pyArgs[1]), &(pyArgs[2])))
        return {};


    // Overloaded function decisor
    // 0: QQuick3DGeometry::addAttribute(QQuick3DGeometry::Attribute::Semantic,int,QQuick3DGeometry::Attribute::ComponentType)
    // 1: QQuick3DGeometry::addAttribute(QQuick3DGeometry::Attribute)
    if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_ATTRIBUTE_IDX], (pyArgs[0])))) {
        overloadId = 1; // addAttribute(QQuick3DGeometry::Attribute)
    } else if (numArgs == 3
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_ATTRIBUTE_SEMANTIC_IDX]))->converter, (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[1])))
        && (pythonToCpp[2] = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_ATTRIBUTE_COMPONENTTYPE_IDX]))->converter, (pyArgs[2])))) {
        overloadId = 0; // addAttribute(QQuick3DGeometry::Attribute::Semantic,int,QQuick3DGeometry::Attribute::ComponentType)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_addAttribute_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // addAttribute(QQuick3DGeometry::Attribute::Semantic semantic, int offset, QQuick3DGeometry::Attribute::ComponentType componentType)
        {
            ::QQuick3DGeometry::Attribute::Semantic cppArg0{QQuick3DGeometry::Attribute::IndexSemantic};
            pythonToCpp[0](pyArgs[0], &cppArg0);
            int cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);
            ::QQuick3DGeometry::Attribute::ComponentType cppArg2{QQuick3DGeometry::Attribute::U16Type};
            pythonToCpp[2](pyArgs[2], &cppArg2);

            if (!PyErr_Occurred()) {
                // addAttribute(QQuick3DGeometry::Attribute::Semantic,int,QQuick3DGeometry::Attribute::ComponentType)
                cppSelf->addAttribute(cppArg0, cppArg1, cppArg2);
            }
            break;
        }
        case 1: // addAttribute(const QQuick3DGeometry::Attribute & att)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QQuick3DGeometry::Attribute cppArg0_local;
            ::QQuick3DGeometry::Attribute *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // addAttribute(QQuick3DGeometry::Attribute)
                cppSelf->addAttribute(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_addAttribute_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_attribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.attribute";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQuick3DGeometry::attribute(int)const->QQuick3DGeometry::Attribute
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // attribute(int)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_attribute_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // attribute(int)const
            QQuick3DGeometry::Attribute cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->attribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_ATTRIBUTE_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QQuick3DGeometryFunc_attribute_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_attributeCount(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.attributeCount";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // attributeCount()const
            int cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->attributeCount();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_boundsMax(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.boundsMax";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // boundsMax()const
            QVector3D cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->boundsMax();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypes[SBK_QVECTOR3D_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_boundsMin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.boundsMin";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // boundsMin()const
            QVector3D cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->boundsMin();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtGuiTypes[SBK_QVECTOR3D_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_clear(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.clear";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // clear()
            cppSelf->clear();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQuick3DGeometryFunc_indexData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.indexData";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // indexData()const
            QByteArray cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->indexData();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_markAllDirty(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.markAllDirty";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // markAllDirty()
            Shiboken::Object::hasCppWrapper(reinterpret_cast<SbkObject *>(self))
                ? cppSelf->::QQuick3DGeometry::markAllDirty()
                : cppSelf->markAllDirty();
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QQuick3DGeometryFunc_primitiveType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.primitiveType";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // primitiveType()const
            QQuick3DGeometry::PrimitiveType cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->primitiveType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX]))->converter, &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_setBounds(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.setBounds";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setBounds", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: QQuick3DGeometry::setBounds(QVector3D,QVector3D)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR3D_IDX], (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR3D_IDX], (pyArgs[1])))) {
        overloadId = 0; // setBounds(QVector3D,QVector3D)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_setBounds_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QVector3D cppArg0_local;
        ::QVector3D *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0].isValue())
            pythonToCpp[0](pyArgs[0], &cppArg0_local);
        else
            pythonToCpp[0](pyArgs[0], &cppArg0);

        if (!Shiboken::Object::isValid(pyArgs[1]))
            return {};
        ::QVector3D cppArg1_local;
        ::QVector3D *cppArg1 = &cppArg1_local;
        if (pythonToCpp[1].isValue())
            pythonToCpp[1](pyArgs[1], &cppArg1_local);
        else
            pythonToCpp[1](pyArgs[1], &cppArg1);


        if (!PyErr_Occurred()) {
            // setBounds(QVector3D,QVector3D)
            cppSelf->setBounds(*cppArg0, *cppArg1);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_setBounds_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_setIndexData(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.setIndexData";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setIndexData", 1, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: QQuick3DGeometry::setIndexData(QByteArray)
    // 1: QQuick3DGeometry::setIndexData(int,QByteArray)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[1])))) {
        overloadId = 1; // setIndexData(int,QByteArray)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[0])))) {
        overloadId = 0; // setIndexData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_setIndexData_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // setIndexData(const QByteArray & data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QByteArray cppArg0_local;
            ::QByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // setIndexData(QByteArray)
                cppSelf->setIndexData(*cppArg0);
            }
            break;
        }
        case 1: // setIndexData(int offset, const QByteArray & data)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QByteArray cppArg1_local;
            ::QByteArray *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (!PyErr_Occurred()) {
                // setIndexData(int,QByteArray)
                cppSelf->setIndexData(cppArg0, *cppArg1);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_setIndexData_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_setPrimitiveType(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.setPrimitiveType";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQuick3DGeometry::setPrimitiveType(QQuick3DGeometry::PrimitiveType)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX]))->converter, (pyArg)))) {
        overloadId = 0; // setPrimitiveType(QQuick3DGeometry::PrimitiveType)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_setPrimitiveType_TypeError;

    // Call function/method
    {
        ::QQuick3DGeometry::PrimitiveType cppArg0{QQuick3DGeometry::PrimitiveType::Points};
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setPrimitiveType(QQuick3DGeometry::PrimitiveType)
            cppSelf->setPrimitiveType(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_setPrimitiveType_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_setStride(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.setStride";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QQuick3DGeometry::setStride(int)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArg)))) {
        overloadId = 0; // setStride(int)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_setStride_TypeError;

    // Call function/method
    {
        int cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setStride(int)
            cppSelf->setStride(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_setStride_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_setVertexData(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.setVertexData";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setVertexData", 1, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: QQuick3DGeometry::setVertexData(QByteArray)
    // 1: QQuick3DGeometry::setVertexData(int,QByteArray)
    if (numArgs == 2
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<int>(), (pyArgs[0])))
        && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[1])))) {
        overloadId = 1; // setVertexData(int,QByteArray)
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], (pyArgs[0])))) {
        overloadId = 0; // setVertexData(QByteArray)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DGeometryFunc_setVertexData_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // setVertexData(const QByteArray & data)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return {};
            ::QByteArray cppArg0_local;
            ::QByteArray *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // setVertexData(QByteArray)
                cppSelf->setVertexData(*cppArg0);
            }
            break;
        }
        case 1: // setVertexData(int offset, const QByteArray & data)
        {
            int cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QByteArray cppArg1_local;
            ::QByteArray *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (!PyErr_Occurred()) {
                // setVertexData(int,QByteArray)
                cppSelf->setVertexData(cppArg0, *cppArg1);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QQuick3DGeometryFunc_setVertexData_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QQuick3DGeometryFunc_stride(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.stride";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // stride()const
            int cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->stride();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QQuick3DGeometryFunc_vertexData(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DGeometry.vertexData";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // vertexData()const
            QByteArray cppResult = const_cast<const ::QQuick3DGeometry *>(cppSelf)->vertexData();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QBYTEARRAY_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQuick3DGeometry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuick3DGeometry_methods[] = {
    {"addAttribute", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_addAttribute), METH_VARARGS},
    {"attribute", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_attribute), METH_O},
    {"attributeCount", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_attributeCount), METH_NOARGS},
    {"boundsMax", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_boundsMax), METH_NOARGS},
    {"boundsMin", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_boundsMin), METH_NOARGS},
    {"clear", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_clear), METH_NOARGS},
    {"indexData", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_indexData), METH_NOARGS},
    {"markAllDirty", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_markAllDirty), METH_NOARGS},
    {"primitiveType", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_primitiveType), METH_NOARGS},
    {"setBounds", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_setBounds), METH_VARARGS},
    {"setIndexData", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_setIndexData), METH_VARARGS},
    {"setPrimitiveType", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_setPrimitiveType), METH_O},
    {"setStride", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_setStride), METH_O},
    {"setVertexData", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_setVertexData), METH_VARARGS},
    {"stride", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_stride), METH_NOARGS},
    {"vertexData", reinterpret_cast<PyCFunction>(Sbk_QQuick3DGeometryFunc_vertexData), METH_NOARGS},

    {nullptr, nullptr} // Sentinel
};

static int Sbk_QQuick3DGeometry_setattro(PyObject *self, PyObject *name, PyObject *value)
{
    PySide::Feature::Select(self);
    if (value && PyCallable_Check(value)) {
        auto plain_inst = reinterpret_cast< ::QQuick3DGeometry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX], reinterpret_cast<SbkObject *>(self)));
        auto inst = dynamic_cast<QQuick3DGeometryWrapper *>(plain_inst);
        if (inst)
            inst->resetPyMethodCache();
    }
    Shiboken::AutoDecRef pp(reinterpret_cast<PyObject *>(PySide::Property::getObject(self, name)));
    if (!pp.isNull())
        return PySide::Property::setValue(reinterpret_cast<PySideProperty *>(pp.object()), self, value);
    return PyObject_GenericSetAttr(self, name, value);
}

} // extern "C"

static int Sbk_QQuick3DGeometry_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QQuick3DGeometry_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
static void * Sbk_QQuick3DGeometrySpecialCastFunction(void *obj, PyTypeObject *desiredType)
{
    auto me = reinterpret_cast< ::QQuick3DGeometry *>(obj);
    if (desiredType == SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DOBJECT_IDX])
        return static_cast< ::QQuick3DObject *>(me);
    else if (desiredType == SbkPySide6_QtCoreTypes[SBK_QOBJECT_IDX])
        return static_cast< ::QObject *>(me);
    else if (desiredType == SbkPySide6_QtQmlTypes[SBK_QQMLPARSERSTATUS_IDX])
        return static_cast< ::QQmlParserStatus *>(me);
    return me;
}


// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuick3DGeometry_Type = nullptr;
static PyTypeObject *Sbk_QQuick3DGeometry_TypeF(void)
{
    return _Sbk_QQuick3DGeometry_Type;
}

static PyType_Slot Sbk_QQuick3DGeometry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    reinterpret_cast<void *>(Sbk_QQuick3DGeometry_setattro)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuick3DGeometry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuick3DGeometry_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuick3DGeometry_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuick3DGeometry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuick3DGeometry_spec = {
    "2:PySide6.QtQuick3D.QQuick3DGeometry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuick3DGeometry_slots
};

} //extern "C"

static void *Sbk_QQuick3DGeometry_typeDiscovery(void *cptr, PyTypeObject *instanceType)
{
    if (instanceType == Shiboken::SbkType< ::QObject >())
        return dynamic_cast< ::QQuick3DGeometry *>(reinterpret_cast< ::QObject *>(cptr));
    if (instanceType == Shiboken::SbkType< ::QQmlParserStatus >())
        return dynamic_cast< ::QQuick3DGeometry *>(reinterpret_cast< ::QQmlParserStatus *>(cptr));
    return {};
}


// Type conversion functions.

// Python to C++ enum conversion.
static void QQuick3DGeometry_PrimitiveType_PythonToCpp_QQuick3DGeometry_PrimitiveType(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQuick3DGeometry::PrimitiveType *>(cppOut) =
        static_cast<::QQuick3DGeometry::PrimitiveType>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_QQuick3DGeometry_PrimitiveType_PythonToCpp_QQuick3DGeometry_PrimitiveType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX]))
        return QQuick3DGeometry_PrimitiveType_PythonToCpp_QQuick3DGeometry_PrimitiveType;
    return {};
}
static PyObject *QQuick3DGeometry_PrimitiveType_CppToPython_QQuick3DGeometry_PrimitiveType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QQuick3DGeometry::PrimitiveType *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QQuick3DGeometry_PythonToCpp_QQuick3DGeometry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuick3DGeometry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QQuick3DGeometry_PythonToCpp_QQuick3DGeometry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QQuick3DGeometry_TypeF())))
        return QQuick3DGeometry_PythonToCpp_QQuick3DGeometry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QQuick3DGeometry_PTR_CppToPython_QQuick3DGeometry(const void *cppIn)
{
    return PySide::getWrapperForQObject(reinterpret_cast<::QQuick3DGeometry *>(const_cast<void *>(cppIn)), Sbk_QQuick3DGeometry_TypeF());

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQuick3DGeometry_SignatureStrings[] = {
    "PySide6.QtQuick3D.QQuick3DGeometry(self,parent:PySide6.QtQuick3D.QQuick3DObject=nullptr)",
    "1:PySide6.QtQuick3D.QQuick3DGeometry.addAttribute(self,semantic:PySide6.QtQuick3D.QQuick3DGeometry.Attribute.Semantic,offset:int,componentType:PySide6.QtQuick3D.QQuick3DGeometry.Attribute.ComponentType)",
    "0:PySide6.QtQuick3D.QQuick3DGeometry.addAttribute(self,att:PySide6.QtQuick3D.QQuick3DGeometry.Attribute)",
    "PySide6.QtQuick3D.QQuick3DGeometry.attribute(self,index:int)->PySide6.QtQuick3D.QQuick3DGeometry.Attribute",
    "PySide6.QtQuick3D.QQuick3DGeometry.attributeCount(self)->int",
    "PySide6.QtQuick3D.QQuick3DGeometry.boundsMax(self)->PySide6.QtGui.QVector3D",
    "PySide6.QtQuick3D.QQuick3DGeometry.boundsMin(self)->PySide6.QtGui.QVector3D",
    "PySide6.QtQuick3D.QQuick3DGeometry.clear(self)",
    "PySide6.QtQuick3D.QQuick3DGeometry.indexData(self)->PySide6.QtCore.QByteArray",
    "PySide6.QtQuick3D.QQuick3DGeometry.markAllDirty(self)",
    "PySide6.QtQuick3D.QQuick3DGeometry.primitiveType(self)->PySide6.QtQuick3D.QQuick3DGeometry.PrimitiveType",
    "PySide6.QtQuick3D.QQuick3DGeometry.setBounds(self,min:PySide6.QtGui.QVector3D,max:PySide6.QtGui.QVector3D)",
    "1:PySide6.QtQuick3D.QQuick3DGeometry.setIndexData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "0:PySide6.QtQuick3D.QQuick3DGeometry.setIndexData(self,offset:int,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtQuick3D.QQuick3DGeometry.setPrimitiveType(self,type:PySide6.QtQuick3D.QQuick3DGeometry.PrimitiveType)",
    "PySide6.QtQuick3D.QQuick3DGeometry.setStride(self,stride:int)",
    "1:PySide6.QtQuick3D.QQuick3DGeometry.setVertexData(self,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "0:PySide6.QtQuick3D.QQuick3DGeometry.setVertexData(self,offset:int,data:typing.Union[PySide6.QtCore.QByteArray, char*])",
    "PySide6.QtQuick3D.QQuick3DGeometry.stride(self)->int",
    "PySide6.QtQuick3D.QQuick3DGeometry.vertexData(self)->PySide6.QtCore.QByteArray",
    nullptr}; // Sentinel

void init_QQuick3DGeometry(PyObject *module)
{
    _Sbk_QQuick3DGeometry_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QQuick3DGeometry",
        "QQuick3DGeometry*",
        &Sbk_QQuick3DGeometry_spec,
        &Shiboken::callCppDestructor< ::QQuick3DGeometry >,
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DOBJECT_IDX],
        0,
        0);
    auto *pyType = Sbk_QQuick3DGeometry_TypeF(); // references _Sbk_QQuick3DGeometry_Type
    InitSignatureStrings(pyType, QQuick3DGeometry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QQuick3DGeometry_Type), Sbk_QQuick3DGeometry_PropertyStrings);
    SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_IDX]
        = Sbk_QQuick3DGeometry_TypeF();

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QQuick3DGeometry_TypeF(),
        QQuick3DGeometry_PythonToCpp_QQuick3DGeometry_PTR,
        is_QQuick3DGeometry_PythonToCpp_QQuick3DGeometry_PTR_Convertible,
        QQuick3DGeometry_PTR_CppToPython_QQuick3DGeometry);

    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry*");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuick3DGeometry).name());
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuick3DGeometryWrapper).name());


    MultipleInheritanceInitFunction func = Shiboken::ObjectType::getMultipleInheritanceFunction(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DOBJECT_IDX]);
    Shiboken::ObjectType::setMultipleInheritanceFunction(Sbk_QQuick3DGeometry_TypeF(), func);
    Shiboken::ObjectType::setCastFunction(Sbk_QQuick3DGeometry_TypeF(), &Sbk_QQuick3DGeometrySpecialCastFunction);
    Shiboken::ObjectType::setTypeDiscoveryFunctionV2(Sbk_QQuick3DGeometry_TypeF(), &Sbk_QQuick3DGeometry_typeDiscovery);

    // Initialization of enums.

    // Initialization of enum 'PrimitiveType'.
    SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX] = Shiboken::Enum::createScopedEnum(Sbk_QQuick3DGeometry_TypeF(),
        "PrimitiveType",
        "2:PySide6.QtQuick3D.QQuick3DGeometry.PrimitiveType",
        "QQuick3DGeometry::PrimitiveType");
    if (!SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "Points", (long) QQuick3DGeometry::PrimitiveType::Points))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "LineStrip", (long) QQuick3DGeometry::PrimitiveType::LineStrip))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "Lines", (long) QQuick3DGeometry::PrimitiveType::Lines))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "TriangleStrip", (long) QQuick3DGeometry::PrimitiveType::TriangleStrip))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "TriangleFan", (long) QQuick3DGeometry::PrimitiveType::TriangleFan))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
        SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], "Triangles", (long) QQuick3DGeometry::PrimitiveType::Triangles))
        return;
    // Register converter for enum 'QQuick3DGeometry::PrimitiveType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX],
            QQuick3DGeometry_PrimitiveType_CppToPython_QQuick3DGeometry_PrimitiveType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QQuick3DGeometry_PrimitiveType_PythonToCpp_QQuick3DGeometry_PrimitiveType,
            is_QQuick3DGeometry_PrimitiveType_PythonToCpp_QQuick3DGeometry_PrimitiveType_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DGEOMETRY_PRIMITIVETYPE_IDX], converter, false);
        Shiboken::Conversions::registerConverterName(converter, "QQuick3DGeometry::PrimitiveType");
        Shiboken::Conversions::registerConverterName(converter, "PrimitiveType");
    }
    // End of 'PrimitiveType' enum.

    PySide::Signal::registerSignals(Sbk_QQuick3DGeometry_TypeF(), &::QQuick3DGeometry::staticMetaObject);
    qRegisterMetaType< ::QQuick3DGeometry::PrimitiveType >("QQuick3DGeometry::PrimitiveType");
    Shiboken::ObjectType::setSubTypeInitHook(Sbk_QQuick3DGeometry_TypeF(), &PySide::initQObjectSubType);
    PySide::initDynamicMetaObject(Sbk_QQuick3DGeometry_TypeF(), &::QQuick3DGeometry::staticMetaObject, sizeof(QQuick3DGeometryWrapper));
}
